/*
	}fuW`

	68040/060  FPU
	68020/030 + 68881/882
	I/O ڑ 68881/882

	LSĂ̊ɑΉ

*/


#include <stdio.h>
#include <stdlib.h>
#include <sys/dos.h>
#include <sys/iocs.h>
#include <math.h>
#include <sys/xmath.h>		/* _FPU_IO */


#define USAGE \
	"}fuW`\n" \
	"<Vѕ>\n" \
	"\tmandel ŏ ő ӂ̒ [TCY [񐔐]]\n" \
	"\t    TCY: 0c256~256hbg^1c512~512hbg [0]\n" \
	"\t    񐔐: 1c [256]\n"


void mandel   (double, double, double, double, int, int, int,
			unsigned short *, int, unsigned short *, int);
void mandel881(double, double, double, double, int, int, int,
			unsigned short *, int, unsigned short *, int);


/* from libc/src/math/_iscopro.c */
#define FPUFLAG() (unsigned char) _iocs_b_bpeek ((void *) 0xcbd) /* FPU type */


/*
typedef struct {
  double re;
  double im;
} complex;
*/

int main (int argc, char *argv[])
{
  double reMin = -2.0, imMax= 2.0, scLen = 4.0;
  int scSize = 0, mxCount = 256;
  int iofpu = 0;
/*
  int x, y;
  complex c;
  unsigned short *a;
  unsigned short col;
*/
  unsigned short *paTable;

  switch (argc) {
  case 6:
    sscanf(argv[5], "%d", &mxCount);
  case 5:
    sscanf(argv[4], "%d", &scSize);
  case 4:
    sscanf(argv[3], "%lf", &scLen);
    sscanf(argv[2], "%lf", &imMax);
    sscanf(argv[1], "%lf", &reMin);
    break;
  default:
    printf(USAGE);
    return EXIT_FAILURE;
  }

  /* FPU ̑݃`FbN */
  if (FPUFLAG() == 0) {
    short buf;
    if (_dos_memcpy ((void *) _FPU_IO, &buf, 2) != 0) {
      printf ("_ZRvZbTڑĂ܂.\n");
      return EXIT_FAILURE;
    }
    iofpu = 1;
  }

  { /* OtBbNʂ͎gp\H */
    char n = _iocs_tgusemd (0, -1);
    if (n == 1 || n == 2) {
      printf ("OtBbNʂ͎gpł.\n");
      return EXIT_FAILURE;
    }
  }

  /* J[R[h\mۂ */
  paTable = malloc((mxCount + 1) * 2);
  if (paTable == NULL) {
    printf("Can't allocate memory\n");
    return EXIT_FAILURE;
  }

  /* ʃ[h̐ݒ */
  if (_dos_c_width (-1) != 0)
    _dos_c_width (0);
  _iocs_b_bpoke ((char *)0x93c, 12);	/* 64K 31kHz */
  _iocs_g_clr_on ();
  { /* \W𒆉ɐݒ */
    int i;
    for (i = 3; i >= 0; i--)
      _iocs_scroll (i, -128, 0);
  }

#ifndef NO_GRAPHIC_MASK
  /* }XN` */
  __asm __volatile ("move.l #'gm'<<16+$ff89,d1\n\t"
		    "moveq #$0e,d0\n\t"
		    "trap #15"		/* gm mask set */
		    : /* no outputs */
		    : /* no outputs */
		    : "d0", "d1");
#endif

  { /* J[R[h\̏ */
    unsigned short* p = paTable;
    int n;
    for (n = 0; n < mxCount; n ++) {
      double t = n / ((mxCount + 1) / 15.0);
      int u, v;
      u = (int)(cos((t)*M_PI) * 14.0 + 26.5);
      u = (u < 32) ? u : 31;
      v = (int)(cos((t + 1.0)*M_PI) * 9.0 + 23.5);
      v = (v < 32) ? v : 31;
      *p++ = _iocs_hsvtorgb((192 * n) / (mxCount + 1), u, v);
    }
    *p = 0;
  }

  { /* `惋[`Ăяo */
    int scCnt = (scSize ? 512 : 256);
    double step = scLen / (double)scCnt;

    int ssp = _iocs_b_super (0);
    (iofpu ? mandel881 : mandel) (reMin, imMax, step, -step, scCnt, scCnt, mxCount,
				(unsigned short*) 0xc00000, 1024, paTable, scSize);
    _iocs_b_super (ssp);
  }

  return EXIT_SUCCESS;
}

/* EOF */
